diff --git a/vhdlparser/vhdlparser.jj b/vhdlparser/vhdlparser.jj
index fbae037..62c9217 100644
--- a/vhdlparser/vhdlparser.jj
+++ b/vhdlparser/vhdlparser.jj
@@ -1900,7 +1900,8 @@ QCString process_declarative_part() :{QCString s,s1;}
  ( s1=process_declarative_item(){s+=s1;} )* { return s;}
 }
 
-void process_statement() : {QCString s,s1,s2;Token *tok=0;}
+//--------------------------------------------------
+void process_statement() : {QCString s,s1,s2;Token *tok=0;Entry *ent=0;}
 {
 [ s=identifier() <COLON_T> ]
 [ <POSTPONED_T> ]
@@ -1908,6 +1909,16 @@ void process_statement() : {QCString s,s1,s2;Token *tok=0;}
                currP=VhdlDocGen::PROCESS;
                current->startLine=getLine();
                current->bodyLine=getLine();
+               
+               ent=current;
+               
+                if(s.isEmpty())
+                 currName=VhdlDocGen::getProcessNumber();
+                 else
+                 currName=s;
+                
+                 createFunction(currName.data(),VhdlDocGen::PROCESS,0);
+                 newEntry();
   }
  <PROCESS_T>
  //try{
@@ -1917,30 +1928,24 @@ void process_statement() : {QCString s,s1,s2;Token *tok=0;}
               if (s2.data())
                   FlowChart::addFlowChart(FlowChart::VARIABLE_NO,s2.data(),0);
                 FlowChart::addFlowChart(FlowChart::BEGIN_NO,"BEGIN",0);
+              
                }
+               
         <BEGIN_T>
         process_statement_part()
         <END_T> [ <POSTPONED_T> ]
          // }catch(...){error_skipto(PROCESS_T);}
         <PROCESS_T> [ identifier() ] <SEMI_T>
- {
-  if(s.isEmpty())
-   currName=VhdlDocGen::getProcessNumber();
-   else
-   currName=s;
-
-   current->name=currName;
-   tempEntry=current;
-   current->endBodyLine=getLine();
-   currP=0;
- if(tok)
-   s1=tok->image.data();
-  createFunction(currName,VhdlDocGen::PROCESS,s1.data());
-  createFlow();
-   currName="";
-   newEntry();
-}
+          {
+             currP=0;
+             ent->endBodyLine=getLine();
+             currName="";
+             createFlow();
+          }
+
 }
+//---------------------------------------------------
+
 
 void process_statement_part() :  {}
 {
